from CvPythonExtensions import *
import CvUtil
import Popup as PyPopup
gc = CyGlobalContext()

T_NONE   = -1 
T_ICE    = 0 #gc.getInfoTypeForString('FEATURE_ICE')
T_JUNGLE = 1 #gc.getInfoTypeForString('FEATURE_JUNGLE')
T_FLOOD  = 3 #gc.getInfoTypeForString('FEATURE_FLOOD_PLAINS')
T_FOREST = 4 #gc.getInfoTypeForString('FEATURE_FOREST')
T_GRASS  = 0 #gc.getInfoTypeForString('TERRAIN_GRASS')
T_PLAIN  = 1 #gc.getInfoTypeForString('TERRAIN_PLAINS')
T_DESERT = 2 #gc.getInfoTypeForString('TERRAIN_DESERT')
T_TUNDRA = 3 #gc.getInfoTypeForString('TERRAIN_TUNDRA')
T_SNOW   = 4 #gc.getInfoTypeForString('TERRAIN_SNOW')
T_FLAT   = 2
T_HILL   = 1 #gc.getInfoTypeForString('PLOT_HILLS')
T_PEAK   = 0 #gc.getInfoTypeForString('PLOT_PEAK')
bRECALC = 1
bREGRAPH = 1

def morphPlot_JungleTropical(plot):
	test_str = ""
	# REMOVE ICE
	if(plot.getFeatureType() == T_ICE):
		test_str += "I"
		plot.setFeatureType(T_NONE, 0)			
	# FOREST TO JUNGLE
	if(plot.getFeatureType() == T_FOREST):
		test_str += "F"
		plot.setFeatureType(T_JUNGLE, 0)
	# PLAINS TO GRASSLAND
	if(plot.getTerrainType() == T_PLAIN):
		test_str += "P"
		plot.setTerrainType(T_GRASS, bRECALC, bREGRAPH)
	# TUNDRA TO GRASSLAND:
	if(plot.getTerrainType() == T_TUNDRA):
		test_str += "T"
		plot.setTerrainType(T_GRASS, bRECALC, bREGRAPH)		
	# SNOW TO GRASSLAND:
	if(plot.getTerrainType() == T_SNOW):
		test_str += "S"
		plot.setTerrainType(T_DESERT, bRECALC, bREGRAPH)
		if(plot.isRiverSide()):
			if(plot.getFeatureType() == T_NONE):
				if(plot.getPlotType() == T_FLAT):
					plot.setFeatureType(T_FLOOD, 0)	
	return test_str

def morphPlot_JungleArid(plot):
	test_str = ""
	# REMOVE ICE
	if(plot.getFeatureType() == T_ICE):
		test_str += "I"
		plot.setFeatureType(T_NONE, 0)			
	# FOREST TO JUNGLE
	if(plot.getFeatureType() == T_FOREST):
		test_str += "F"
		plot.setFeatureType(T_JUNGLE, 0)
	# PLAINS TO DESERT
	if(plot.getTerrainType() == T_PLAIN):
		test_str += "P"
		plot.setTerrainType(T_DESERT, bRECALC, bREGRAPH)
		if(plot.isRiverSide()):
			if(plot.getFeatureType() == T_NONE):
				if(plot.getPlotType() == T_FLAT):
					plot.setFeatureType(T_FLOOD, 0)	
	# TUNDRA TO DESERT:
	if(plot.getTerrainType() == T_TUNDRA):
		test_str += "T"
		plot.setTerrainType(T_DESERT, bRECALC, bREGRAPH)
		if(plot.isRiverSide()):
			if(plot.getFeatureType() == T_NONE):
				if(plot.getPlotType() == T_FLAT):
					plot.setFeatureType(T_FLOOD, 0)			
	# SNOW TO DESERT:
	if(plot.getTerrainType() == T_SNOW):
		test_str += "S"
		plot.setTerrainType(T_DESERT, bRECALC, bREGRAPH)
		if(plot.isRiverSide()):
			if(plot.getFeatureType() == T_NONE):
				if(plot.getPlotType() == T_FLAT):
					plot.setFeatureType(T_FLOOD, 0)	
	return test_str

def morphPlot_JungleTemperate(plot):
	test_str = ""
	# REMOVE ICE
	if(plot.getFeatureType() == T_ICE):
		test_str += "I"
		plot.setFeatureType(T_NONE, 0)			
	# FOREST TO JUNGLE
	if(plot.getFeatureType() == T_FOREST):
		test_str += "F"
		plot.setFeatureType(T_JUNGLE, 0)
	# PLAINS TO GRASSLAND
	if(plot.getTerrainType() == T_PLAIN):
		test_str += "P"
		plot.setTerrainType(T_GRASS, bRECALC, bREGRAPH)
	# TUNDRA TO DESERT:
	if(plot.getTerrainType() == T_TUNDRA):
		test_str += "T"
		plot.setTerrainType(T_DESERT, bRECALC, bREGRAPH)
		if(plot.isRiverSide()):
			if(plot.getFeatureType() == T_NONE):
				if(plot.getPlotType() == T_FLAT):
					plot.setFeatureType(T_FLOOD, 0)			
	# SNOW TO DESERT:
	if(plot.getTerrainType() == T_SNOW):
		test_str += "S"
		plot.setTerrainType(T_DESERT, bRECALC, bREGRAPH)
		if(plot.isRiverSide()):
			if(plot.getFeatureType() == T_NONE):
				if(plot.getPlotType() == T_FLAT):
					plot.setFeatureType(T_FLOOD, 0)	
	return test_str
	
def morphPlot_JungleCold(plot):
	test_str = ""
	# FOREST TO JUNGLE
	if(plot.getFeatureType() == T_FOREST):
		test_str += "F"
		plot.setFeatureType(T_JUNGLE, 0)
	# PLAINS TO GRASSLAND
	if(plot.getTerrainType() == T_PLAIN):
		test_str += "P"
		plot.setTerrainType(T_GRASS, bRECALC, bREGRAPH)
	return test_str
	
def morphPlot_Jungle(clime, plot):
	if(clime == 1):
		return morphPlot_JungleTropical(plot)
	elif(clime == 2):
		return morphPlot_JungleArid(plot)
	elif(clime == 4):
		return morphPlot_JungleCold(plot)
	else:
		return morphPlot_JungleTemperate(plot)



def morphMap_Pirate():
	popup = PyPopup.PyPopup()
	test_str = ""
		
	themap = gc.getMap()
	clime = themap.getClimate()
	nplots = themap.numPlots()
	ploti = 0

	add_bonus = {'GOLD':3, 'SILVER':2, 'GEMS':1, 'BANANA':4, 'WINE':3}
	no_bonus = {'GOLD':[],'SILVER':[],'GEMS':[],'BANANA':[],'WINE':[]}
	count_ice = 0
	while(ploti < nplots):
		plot = themap.plotByIndex(ploti)
		test_str += str(plot.getTerrainType())
		if(plot.getTerrainType() == T_PLAIN):
			count_ice += 1
		ploti += 1
	if(count_ice < 2):
		popup.setBodyString("MAP ALREADY PIRATED!! ")	
		popup.launch()
		return

	test_str = ""
	ploti = 0
	while(ploti < nplots):
		plot = themap.plotByIndex(ploti)
		test_str += morphPlot_Jungle(clime, plot)
		if(plot.getBonusType(T_NONE) == T_NONE):
			if(plot.getPlotType() != T_PEAK):
				if(plot.getPlotType() == T_HILL):
					no_bonus['GOLD'].append(plot)
					no_bonus['SILVER'].append(plot)
					if(plot.getTerrainType() == T_GRASS):
						no_bonus['WINE'].append(plot)
				elif(plot.getTerrainType() == T_DESERT):
					no_bonus['GOLD'].append(plot)
					no_bonus['SILVER'].append(plot)			
				if(plot.getFeatureType() == T_JUNGLE):
					no_bonus['BANANA'].append(plot)
					no_bonus['GEMS'].append(plot)
		ploti += 1
		
	#RESOURCES
	for rTEXT, plots in no_bonus.iteritems():
		if(test_str != ""):
			test_str += "\n\n"
		test_str += str(rTEXT)

		rID = gc.getInfoTypeForString("BONUS_" + str(rTEXT))
		countPlot = len(plots) / (add_bonus[rTEXT] + 1.0)
		countPlot = int(countPlot)
		if(countPlot < 1):
			countPlot = 1
		i = 0
		iPlot = -1
		add_plot = []
		while(i < add_bonus[rTEXT]):
			iPlot += countPlot
			if(iPlot < len(plots)):
				add_plot.append(plots[iPlot])
			i += 1
		test_str += "\nCOUNT:" + str(len(plots)) + "   STEP:" + str(countPlot) + "   TIMES:" + str(len(add_plot)) + "/" + str(add_bonus[rTEXT])
		for p in plots:
			if(p in add_plot):
				p.setBonusType(rID)
				test_str += "\nADDED " + rTEXT + " TO (" + str(p.getX()) + "," + str(p.getY()) + ")"	
			
	test_str += "\n\nEOF!"
	#popup.setBodyString( test_str )	
	popup.setBodyString( "MAP PIRATED!")	
	popup.launch()
	