from CvPythonExtensions import *
import CvUtil
import Popup as PyPopup
import RandomPirateShipNames
gc = CyGlobalContext()


SALVAGE_UNIT_VALUE = {}
SALVAGE_UNIT_VALUE[gc.getInfoTypeForString('UNIT_WORKBOAT')]  = 25.0
SALVAGE_UNIT_VALUE[gc.getInfoTypeForString('UNIT_GALLEY')]    = 10.0
SALVAGE_UNIT_VALUE[gc.getInfoTypeForString('UNIT_CARAVEL')]   = 50.0
SALVAGE_UNIT_VALUE[gc.getInfoTypeForString('UNIT_PIRATE_CARAVEL')] = 100.0
SALVAGE_UNIT_VALUE[gc.getInfoTypeForString('UNIT_GALLEON')]   = 30.0
SALVAGE_UNIT_VALUE[gc.getInfoTypeForString('UNIT_FRIGATE')]   = 20.0
SALVAGE_UNIT_VALUE[gc.getInfoTypeForString('UNIT_IRONCLAD')]  = 100.0
SALVAGE_UNIT_VALUE[gc.getInfoTypeForString('UNIT_TRANSPORT')] = 50.0
SALVAGE_SCALE = 0.35
SALVAGE_LEVEL_MULTIPLIER = 0.1
PIRATE_WAR_COMMERCE = 0.3
CAPTURE_LIST = []

def quickPop(popstr):
	popup = PyPopup.PyPopup()
	popup.setBodyString(popstr)
	popup.launch()



def getUnitSalvage(unit):
	salvage = 30.0
	unitTypeID = unit.getUnitType()
	if(SALVAGE_UNIT_VALUE.has_key(unitTypeID)):
		salvage = SALVAGE_UNIT_VALUE[unitTypeID]
	salvage *= (1.0  + (unit.getLevel() - 1) * SALVAGE_LEVEL_MULTIPLIER)
	salvage *= SALVAGE_SCALE
	return int(salvage)

def countPlayerShipsXY(playerID, atX, atY):
	player = gc.getPlayer(playerID)
	count = 0
	unit, uniti = player.firstUnit(0)
	while(unit):
		match = 1
		if(unit.getUnitCombatType() != gc.getInfoTypeForString('UNITCOMBAT_NAVAL')):
			match = 0
		if(unit.getX() != atX):
			match = 0
		if(unit.getY() != atY):
			match = 0
		if(match):
			count += 1
		unit, uniti = player.nextUnit(uniti, 0)
	return count
		
def isNotEnemyTerritory(player, plot):
	ownerID = plot.getOwner()
	owner = gc.getPlayer(ownerID)
	playerID = player.getID()
	if(ownerID == playerID):
		#quickPop("Owner = Self")
		return True
	if(ownerID == -1):
		#quickPop("Owner = None")
		return True
	oTeamID = owner.getTeam()
	pTeamID = player.getTeam()
	if(oTeamID == pTeamID):
		#quickPop("Owner = Team")
		return True
	oTeam = gc.getTeam(oTeamID)
	if(oTeam.isOpenBorders(pTeamID)):
		#quickPop("Owner = Friend")
		return True
	else:
		#quickPop("Owner = Enemy")
		return False

def isPlotCoast(plot):
	if(plot.getTerrainType() == gc.getInfoTypeForString('TERRAIN_COAST')):
		return True
	#quickPop("Not Coast")
	return False

def isPlayerAtWar(player, warPlayer):
	pTeam = gc.getTeam(player.getTeam())
	if(pTeam.isAtWar(warPlayer.getTeam())):
		return true
	return false

def getPirateWarCommerce(warPlayer):
	imports = warPlayer.calculateTotalImports(gc.getInfoTypeForString('YIELD_COMMERCE'))
	imports *= PIRATE_WAR_COMMERCE
	return imports 





def onCombatResult(argsList):
	unitW, unitL = argsList
	salvageMultiplier = 0.0
	capture = 0

	playerW = gc.getPlayer(unitW.getOwner())
	plotL = unitL.plot()

	strTest = "0"
	if(playerW.isTurnActive()):
		strTest += "1"
		if(unitW.isHasPromotion(gc.getInfoTypeForString('PROMOTION_PIRATE1'))):
			salvageMultiplier = 1.0
		if(unitW.isHasPromotion(gc.getInfoTypeForString('PROMOTION_PIRATE2'))):
			salvageMultiplier += 0.5
		if(unitW.isHasPromotion(gc.getInfoTypeForString('PROMOTION_PIRATE3'))):
			strTest += "2"
			salvageMultiplier += 0.2
			if(isPlotCoast(plotL)):
				strTest += "3"
				if(isNotEnemyTerritory(playerW, plotL)):
					strTest += "4"
					countShip = countPlayerShipsXY(unitL.getOwner(), plotL.getX(), plotL.getY())
					#quickPop("Number of Ships: " + str(countShip))
					if(countShip <= 1):
						#quickPop("CAPTURE")
						strTest += "5"
						capture = 1
	if(capture):
		CAPTURE_LIST.append((unitW.getOwner(), unitL.getUnitType(), plotL.getX(), plotL.getY()))			
	if(salvageMultiplier >= 0.001):
		salvage = getUnitSalvage(unitL)
		if(salvage < 0):
			salvage = 0

		salvage *= salvageMultiplier
		salvage = int(salvage)
		playerW.changeGold(salvage)

		strSalvage = "You plunder " + str(salvage) + " gold from the wreckage."
		CyInterface().addMessage(playerW.getID(), 1, 10, strSalvage, "AS2D_GOODY_GOLD", 0, "", 0, 0, 0, false, false)



def onUnitMove(event, argsList):
	global CAPTURE_LIST
	pPlot, pUnit = argsList
	capture = 0
	for x in CAPTURE_LIST:
		cPlayerID, cUnitID, cX, cY = x
		if(pUnit.getOwner() == cPlayerID):
			if(pPlot.getX() == cX):
				if(pPlot.getY() == cY):
					capture = 1
					cUnit = gc.getPlayer(cPlayerID).initUnit(cUnitID, cX, cY, UnitAITypes.NO_UNITAI)
					cUnit.finishMoves()			
					cUnit.changeMoves(-1)			
					cUnit.changeDamage(int(0.9 * cUnit.maxHitPoints()), -1)
					strCapture = cUnit.getNameNoDesc()
					if(strCapture == ""):
						strCapture = cUnit.getName()
					strCapture = "Your crew salvaged the remains of the " + strCapture + "!" 	
					CyInterface().addMessage(cPlayerID, 1, 10, strCapture, "AS2D_PILLAGED", 0, "Art/Interface/Buttons/Units/Caravel.dds", 0, cX, cY, True, True)
					CyInterface().selectUnit(cUnit, 1, 1, 1)

	if(capture):
		CAPTURE_LIST = []
	pass


def onBeginPlayerTurn(event, argsList):
	iGameTurn, iPlayer = argsList
	player = gc.getPlayer(iPlayer)
	if(player.hasTrait(gc.getInfoTypeForString('TRAIT_PIRATE'))):
		spoilsOfWar = 0.0
		iP = 0
		while(iP <= 18): 
			warPlayer = gc.getPlayer(iP)
			if(warPlayer):
				if(warPlayer.isAlive()):
					if(not warPlayer.isBarbarian()):
						if(isPlayerAtWar(player, warPlayer)):
							spoilsOfWar += getPirateWarCommerce(warPlayer)
			iP += 1
		spoilsOfWar = int(spoilsOfWar)
		if(spoilsOfWar > 0):
			player.changeGold(spoilsOfWar)
			strSpoils = "You have plundered " + str(spoilsOfWar) + " gold from enemy trade routes."
			CyInterface().addMessage(iPlayer, 0, 10, strSpoils, "AS2D_GOODY_GOLD", 0, "", 0, 0, 0, false, false)



def onUnitCreated(event, argsList):
    unit = argsList[0]
    player_id = unit.getOwner()
    player = gc.getPlayer(player_id)
    if(unit.getUnitType() == gc.getInfoTypeForString('UNIT_PIRATE_CARAVEL')):
        if(CyStatistics().getPlayerNumUnitsBuilt(player_id, unit.getUnitType()) == 0):
            uName = RandomPirateShipNames.randomName()
            uLeader = player.getLeaderType()
            if(uLeader == gc.getInfoTypeForString("LEADER_PIRATE_MALE")):
                uName = "Zento's Revenge"
            if(uLeader == gc.getInfoTypeForString("LEADER_PIRATE_MALE2")):
                uName = "Daring Davy Dandy"
            if(uLeader == gc.getInfoTypeForString("LEADER_PIRATE_FEMALE")):
                uName = "The Jaeded Hart"
            unit.setName(uName)
        else:
            uName = unit.getNameNoDesc()
            if(uName == ""):
                uName = "RANDOM"
            if(uName == "RANDOM"):
                uName = RandomPirateShipNames.randomName()
                unit.setName(uName)




    
