import random                                                  

WORDS = {
# DESCRIPTORS-THING
1  : ['Lucky', 'Deadly', 'Rusty', 'Sunken', 'Horrible', 'Evil', 'Fearful', 'Vile', 'Foul', 'Black', 'Red', 'Shameful', 'Damned', 'Horrid', 'Poison', 'Hellish', 'Dirty', 'Gold', 'Bloody', 'Cursed', 'Disgraceful', 'Dark', 'Hell-born'],
# DESCRIPTORS-PERSON
2  : ['Lucky', 'Wailing', 'Guilty', 'Dreaded', 'Deadly', 'Horrible', 'Wandering', 'Evil', 'Hateful', 'Fearful', 'Cruel', 'Fallen', 'Vile', 'Foul', 'Sad', 'Shameful', 'Decietful', 'Damned', 'Horrid', 'Angry', 'Hellish', 'Dishonorable', 'Greedy', 'Awful', 'Lustful', 'Screaming', 'Scurvy', 'Dirty', 'Bloody', 'Cursed', 'Howling', 'Dreaming', 'Disgraceful', 'Vicious', 'Mad', 'Hell-born'],
# POSSESSORS
4  : ["Kraken's", "Ghost's", "Dead Man's", "Mermaid's", "Sea's", "Captain's", "Pirate's", "Killer's", "Ocean's", "Satan's", "Privateer's", "Murderer's", "Neptune's", "Devil's", "Night's", "Buccaneer's", "Hades'", "Posideon's", "Dragon's", "Davy Jones'"],
# OBJECTS
8  : ['Bucket', 'Keg', 'Saber', 'Trident', 'Mystery', 'Blade', 'Lightning', 'Curse', 'Thunder', 'Nightmare', 'Treasure', 'Plunder', 'Plague', 'Doom', 'Doubloon', 'Jewel', 'Star', 'Death', 'Poison', 'Pearl', 'Storm', 'Hoard', 'Compass', 'Night', 'Dagger', 'Gold', 'Lie', 'Secret', 'Sword', 'Cannon', 'Grail', 'Dream', 'Cutlass'],
# ABTRACTS
16 : ['Pride', 'Cruelty', 'Insanity', 'Scream', 'Shame', 'Damnation', 'Anger', 'Fear', 'Hate', 'Horror', 'Doom', 'Greed', 'Deciet', 'Disgrace', 'Death', 'Dishonor', 'Cry', 'Sadness', 'Howl', 'Fall', 'Rage', 'Madness', 'Lust'],
# PERSON-MAJOR
32 : ['Kraken', 'Sea Witch', 'Mermaid', 'Devil', 'Privateer', 'Wolf', 'Executioner', 'Shark', 'Serpent', 'Manta', 'Killer', 'Knave', 'Corsair', 'Captain', 'Pirate', 'Murderer', 'Raider', 'Eel', 'Demon', 'Buccaneer', 'Hangman'],
# PERSON-LESSER
64 : ['Dog', 'Parrot', 'Lackey', 'Ghost', 'Lover', 'Handmaiden', 'Executioner', 'Serpent', 'Whore', 'Killer', 'Knave', 'Murderer', 'Strumpet', 'Raider', 'Servant', 'Hangman', 'Slave', 'Wench'],
# LOCATION
128: ['the Hurricane', 'the South', 'the Ocean', 'the North', 'the East', 'the Caribbean', 'Tortuga', 'Hell', 'Hades', 'the Sargasso Sea', 'Atlantis', 'the West', 'the Seven Seas', 'the Sea'],
# ACTOR-PREFIX
256: ["Black", "Never", "Blade", "Death", "Demon", "Devil", "Doom", "Dragon", "Fear", "Gold", "Hell", "Jewel", "Night", "Plague", "Red", "Sea", "Wolf", "Slave", "Storm", "Thunder", "Free", "Reef", "Wave", "Fire", "Blood", "Water", "Sand", "Wind"],
# ACTORS
512: ["Lover", "Runner", "Rider", "Keeper", "Finder", "Seeker", "Killer", "Raper", "Trader", "Wrecker", "Crusher", "Screamer", "Kegger", "Hunger", "Bane", "Fisher", "Song"]
}
    
PATTERNS = [
    ((1,8,128), "The %s %s of %s"),
    ((1,8), "The %s %s"),
    ((1,8), "The %s %s"),
    ((1,16), "The %s %s"),
    ((1,16), "The %s %s"),
    ((2,32), "The %s %s"),
    ((2,32), "The %s %s"),
    ((2,64), "The %s %s"),
    ((2,64), "The %s %s"),
    ((4,8), "%s %s"),
    ((4,8), "%s %s"),
    ((4,16), "%s %s"),
    ((4,16), "%s %s"),
    ((4,64), "%s %s"),
    ((4,64), "%s %s"),
    ((16,32), "The %s of the %s"),
    ((16,32), "The %s of the %s"),
    ((16,128), "The %s of %s"),
    ((16,128), "The %s of %s"),
    ((1,8,128), "The %s %s of %s"),
    ((2,32,128), "The %s %s of %s"),
    ((2,64,128), "The %s %s of %s"),
    ((4,1,8), "%s %s %s"),
    ((256, 512), "%s-%s")
]

def getWordsByShort(f):
    return WORDS[f]

def randomPattern():
    return random.choice(PATTERNS)

def randomName():
    flags, patternstr = randomPattern()
    words = []
    for i in flags:
        w = getWordsByShort(i)
        if(len(w) < 1):
            words.append("Unknown")
        else:
            words.append(random.choice(w))

    if(len(words) >= 5):
        wordtuple = (words[0], words[1], words[2], words[3], words[4])
    elif(len(words) == 4):
        wordtuple = (words[0], words[1], words[2], words[3])
    elif(len(words) == 3):
        wordtuple = (words[0], words[1], words[2])
    elif(len(words) == 2):
        wordtuple = (words[0], words[1])
    elif(len(words) == 1):
        wordtuple = (words[0])
    else:
        return "Error"

    name = patternstr % wordtuple
    return name

def batch(x = 20):
    i = 0
    while(i < x):
        print randomName()
        i += 1
